/* Copyright (C) 2005  Jean-Franois Geyelin */

#include "all.h"
#include "sprites.h"
#include "GrayClipISSprite8.h"




static short xXx[] = {34,	/*5,*/  20,	50,	80};
static short yYy[] = {125, /*141,*/ 160,160,160};

#define MIDDLE (256-8)
void create_stalag(STALAG_STRUCT* s) {
	s->b=0;
	s->a=0;
	short n=random(4);
	s->x=xXx[n];
	s->y=yYy[n];
	if (rand()&1)
	s->x = MIDDLE-s->x;
	s->s_y = s->y<<V_S;
	s->is_falling = FALSE;
	s->animation_on=TRUE;
	s->frame = 0;
	s->shine = 0;
}
#undef MIDDLE


void erf1() {
//e=mc^2
}

void erf2(STALAG_STRUCT* s) {
	s->frame+=3*16;
}

void erf3(STALAG_STRUCT* s) {
	s->x++;
	s->shine=-s->shine;
}

void erf4(STALAG_STRUCT* s) {
	s->x--;
	s->shine=-s->shine;
}

void erf5(STALAG_STRUCT* s) {
	s->is_falling = TRUE;
	s->s_vy = 0;
	//s->y+=20;
	s->s_y=s->y<<V_S;
}

void erf6(STALAG_STRUCT* s) {
	s->shine = 3;
}



static void (*huhu_gnii[])(STALAG_STRUCT* s) = {erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,              erf2,erf1,erf1,  erf1,erf1,erf1,erf1,erf1,erf1,   erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,erf1,    erf2, erf6,erf3,     erf2,erf4,erf1,erf3,erf1,erf4,erf5};
//JGFYMF

void move_stalag(STALAG_STRUCT* s) {
	if (s->is_falling==FALSE) {
		s->b++;
		
		if (s->b==4) {
			s->b = 0;
			huhu_gnii[s->a](s);
			s->a++;
		}
	}
	else
	{
		s->s_y+=s->s_vy;
		s->s_vy+=(s->s_vy<(3<<V_S))<<(V_S-4);
		s->y = s->s_y>>V_S;
		s->animation_on = s->y<=300;
	}
}

void init_small_explosion(EXPLODING_STALAG_STRUCT * s,STALAG_STRUCT * s2) {
	s->time = 10;
	s->x = s2->x;
	s->y = s2->y;
}